###################################################################################################
# Declaring new directories to be added to the project
###################################################################################################
# list()					= List declaration "DON'T CHANGE"
# PROJECT_ADDITIONAL_DIRS	= Variable containing the listed direcotries "DON'T CHANCE"
# .							= This indicates that the root file needs to de included "DON'T REMOVE"
#
# To include a new folder containing headers or sources that you want to compile
# - The root of the project is where the main.c is located 
# - Let's suppose your main.c is under : /home/yourUserName/YOurProjectName/main.c
# - If we Make a new "Src" folder under /home/yourUserName/YOurProjectName/Src
# - To add it to the project, 
#	- Just include the Direwctory name "Src" the the Declarion WITHOUT THE LAST "/"
#	- the declaration should look like this : list(APPEND PROJECT_ADDITIONAL_DIRS . Src)	
list(APPEND PROJECT_ADDITIONAL_DIRS .)	

###################################################################################################
# Declaring sources to be compiled for the project. 
###################################################################################################
# KED will look in every PROJECT_ADDITIONAL_DIRS list an search for sources  
# decalred by PROJECT_TO_COMPILE_LIST list
#
# To add a source file to the compilation
# - Let's continue where we left off for the Directory inclusion.
# - Now let's say you have source file named sensor.c located as follow : 
#	-> /home/yourUserName/YOurProjectName/Src/sensor.c
# - To let KED know that you want this source to be compiled, you simply ned to add it the list
# - This would look like this : set(PROJECT_TO_COMPILE_LIST sensors.c)
set(PROJECT_TO_COMPILE_LIST)

# If you still have some question please have a look under : ked/libraries/examples/ 
# There you can find some example projects with their corresponding "projectDefinitions.cmake".
# To try one of them just copy the entirety of one example folders contend to the root of your
# project where ked/ is located.
